function r = Disl_WRSS(x, origin, xy, nu, d, W)
%	x -- model vector
%	d -- data
%	W -- Weight Matrix
%	nu -- poissson's ratio
%	xy coordinates of stations
	

%    Input: Dislocation Geometry
%               geom(1) = wid = fault width in dip direction (km)
%               geom(2) = dep = depth of fault bottom (km)
%               geom(3) = dip = dip angle (degrees)
%               geom(4) = latitude of one end (decimal degrees)
%               geom(5) = longitude of one end (decimal degrees)
%               geom(6) = latitude of second end (decimal degrees)
%               geom(7) = longitude of second end (decimal degrees)
%               geom(8) = srike slip (m)
%               geom(9) = dip slip (m)
%               geom(10) = opening slip (m)

%convert global to local geometry
	nf = length(x)/10;
	[geom, dis_geom] = x2geom(x, origin);

%	for i=1:nf
%		first = 10*(i-1)+1;
%		geom(i,:) = x(first:first+9)';
%        	xy_1end(i,:)  = llh2localxy([geom(i,4);  geom(i,5)], origin);
%       		xy_2end(i,:)  = llh2localxy([geom(i,6);  geom(i,7)], origin);
%        	len(i) = sqrt(  (xy_1end(i,1) -  xy_2end(i,1) )^2 + ...
%			(xy_1end(i,2) - xy_2end(i,2))^2);
%       		strik(i) = (180/pi)*atan2((xy_2end(i,2) -  xy_1end(i,2) ), ...
%			(xy_2end(i,1) -  xy_1end(i,1) ));
%        	delE(i) = xy_1end(i,1); 
%        	delN(i) = xy_1end(i,2); 
%       	dis_geom(i,:) = [len(i),geom(i,1),geom(i,2),geom(i,3),strik(i),...
%			delE(i),delN(i),geom(i,8), geom(i,9), geom(i,10)];
%	end


%Plot Geometry in Local Cartesian Coordinates
%        figure
%        plot(xy(:,1), xy(:,2), 'o'), axis('equal'), hold on
%        for i=1:nf
%         displot(dis_geom(i,:))
%        end
%	title('Geometry in Local Cartesian Coordiantes')


%predict relative displacements
        ndata = length(d);
        nvec = ndata/3;
        clear u_rel; u_rel = zeros(3,nvec);

        for i=1:nf
          u_rel = u_rel + relative_disp(nu, dis_geom(i,:), xy);
        end

% compute weighted residuals
        dhat = u_rel(:);
        r = W*(d - dhat);

