function r = Disl_wr(x, origin, xy, nu, d, W, geom_start)
%
% Compute the weighted residual for Dislocation Model
%	x -- model vector
%	d -- data
%	W -- Weight Matrix
%	nu -- poissson's ratio
%	xy coordinates of stations
	
    	nf = length(x)/7;
   	ndata = length(d);
        nvec = ndata/3;
        u_rel = zeros(3,nvec);

	[geom_short, dis_geom_short] = x2geom(x, origin);
	dis_geom = [dis_geom_short, geom_start(:,8:10)];

%For Testing
%        figure
%        plot(xy(:,1), xy(:,2), 'o'), axis('equal'), hold on
%        for i=1:nf
%         displot(dis_geom(i,:))
%        end
%	 title('Geometry in Local Cartesian Coordiantes')

        G = MakeGgps(dis_geom, xy, nu);
        dhat = G*pinv(W*G)*W*d;

% compute weighted residual sum of squares
        r = W*(d - dhat);

