function G = MakeGvolgps(vol_geom, xy, nu)

%Subroutine to make design matrix for volume sources

%Input:
%       vol_geom        - Source Geometry
%       xy              - xy coordinates of statinos
%       nu              - Poisson's ratio
 
[nv,nvels]  = size(vol_geom);
[nsta,nel2] = size(xy);
ndata       = (nsta-1)*3; 	 % this works for GPS data

G = zeros(ndata,nv);

for i=1:nv
	u_rel = vol_rel_disp(nu, [vol_geom(i,1:3),1], xy);
        G(:,i) = u_rel(:);
end
