      subroutine mexFunction(nlhs, plhs, nrhs, prhs)
c
c     A Matlab gateway routine for bvls
c
      integer plhs(*), prhs(*)
      integer nlhs, nrhs
c
      integer mxGetM, mxGetN, mxGetPr, mxCreateFull
      integer ma,na,mm,nn,mn
      parameter (mm=10000,nn=10000,mn=10000000)
      integer mb,nbl,nbu,nx
      integer pact,pzz
      integer a,b,bl,ub,x,xb,w,act,zz,istate,istateb,loopA,loopAi
      integer istatei(10000)
c
      real*8 ar(mn),br(nn),blr(nn),bur(nn),xr(nn)
      real*8 wr(nn),actr(mn),zzr(mm),istater(nn),loopAr 

c
c
c check for proper number of arguments
c
      if (nrhs .ne. 6) then
        call mexErrMsgTxt('bvls requires 6 output arguments')
      elseif (nlhs .ne. 4) then
        call mexErrMsgTxt('bvls requires 4 input arguments')
      endif
c
c Check the dimensions of the input matrices and vectors. 
c
      ma = mxGetM(prhs(1))
      na = mxGetN(prhs(1))
c
      mt = mxGetM(prhs(2))
      nt = mxGetN(prhs(2))
      mb = max(mt,nt)
c
      mt = mxGetM(prhs(3))
      nt = mxGetN(prhs(3))
      nbl = max(mt,nt)
c
      mt = mxGetM(prhs(4))
      nt = mxGetN(prhs(4))
      nbu = max(mt,nt)
c
      mt = mxGetM(prhs(5))
      nt = mxGetN(prhs(5))
      nx = max(mt,nt)
c
c      if (ma.lt.na) then
c        call mexErrMsgTxt('The design matrix has fewer rows
c     + than columns.')
      if (mb.ne.ma) then
        call mexErrMsgTxt('The number of data is not equal
     + to the number of rows in the design matrix.')
      elseif (nbl.ne.na) then
        call mexErrMsgTxt('The number of lower bounds is not
     + equal to the number of columns in the design matrix.')
      elseif (nbu.ne.na) then
        call mexErrMsgTxt('The number of upper bounds is not
     + equal to the number of columns in the design matrix.')
      elseif (nx.ne.na) then
        call mexErrMsgTxt('The number of model elements is not
     + equal to the number of columns in the design matrix.')
      endif
c
c Create  matrices for return arguments

      plhs(1) = mxCreateFull(1,na,0)
      plhs(2) = mxCreateFull(1,na,0)
      plhs(3) = mxCreateFull(1,na+1,0)
      plhs(4) = mxCreateFull(1,1,0)  
c
c Create work matrices
      pact = mxCreateFull(ma,na+2,0)
      pzz = mxCreateFull(ma,1,0)

c
c Dereference arguments to get array pointers 
      xb      	= mxGetPr(plhs(1))
      w      	= mxGetPr(plhs(2))
      istateb	= mxGetPr(plhs(3))
      loopA    	= mxGetPr(plhs(4))
      a		= mxGetPr(prhs(1))
      b		= mxGetPr(prhs(2))
      bl	= mxGetPr(prhs(3))
      ub	= mxGetPr(prhs(4))
      x      	= mxGetPr(prhs(5))
      istate    = mxGetPr(prhs(6))
      act      	= mxGetPr(pact)
      zz      	= mxGetPr(pzz)
c
c Call the Computational Routine
      call mxCopyPtrToReal8(a,ar,ma*na)
      call mxCopyPtrToReal8(b,br,ma)
      call mxCopyPtrToReal8(bl,blr,na)
      call mxCopyPtrToReal8(ub,bur,na)
      call mxCopyPtrToReal8(x,xr,na)
      call mxCopyPtrToReal8(w,wr,na)
      call mxCopyPtrToReal8(zz,zzr,ma)
      call mxCopyPtrToReal8(istate,istater,na+1)
  
      do 100 j=1,na+1
        istatei(j)=istater(j)
 100  continue
      
      call bvls(1,ma,na,ar,br,blr,bur,xr,wr,actr,zzr,istatei,loopAi)
c
c  Copy output values into matrix pointers

      call mxCopyReal8ToPtr(xr,xb,na)
      call mxCopyReal8ToPtr(wr,w,na)
      do 200 j=1,na+1
        istater(j)=istatei(j)
 200  continue
      call mxCopyReal8toPtr(istater,istateb,na+1)
      loopAr=loopAi
      call mxCopyReal8ToPtr(loopAr,loopA,1)
c
      return
      end

