function [x_out,y_out,meanvalue,maxvalue] = getdata(image,type)

A = imread(image,type);
A = double(A);

imagesc(A);
colormap gray
axis equal;
axis image;

pause;

fprintf('Click on upper left axis location\n');
[x_ul,y_ul] = ginput(1);
ul_x = input('What x-value was this?');
ul_y = input('What y-value was this?');

fprintf('Click on lower left axis location\n');
[x_ll,y_ll] = ginput(1);
ll_x = input('What x-value was this?');
ll_y = input('What y-value was this?');

fprintf('Click on lower right axis location\n');
[x_lr,y_lr] = ginput(1);
lr_x = input('What x-value was this?');
lr_y = input('What y-value was this?');

% Determine scale:

yscale = sqrt( (x_ul - x_ll).^2 + (y_ul - y_ll).^2)./sqrt( (ul_x - ll_x).^2 ...
   + (ul_y - ll_y).^2)

xscale = sqrt( (x_lr - x_ll).^2 + (y_lr - y_ll).^2)./sqrt( (lr_x - ll_x).^2 ...
   + (lr_y - ll_y).^2)


beta = -atan((y_ll - y_lr)./(x_ll - x_lr));

flag = 0;

counter = 1;

fprintf('Digitize data... (2 button to exit)\n');

while(~flag)
   [xpt,ypt,b] = ginput(1);
   
   x_data(counter) = xpt;
   y_data(counter) = ypt;
   
   if(b == 2)
      flag = 1;
   end
   
   counter = counter + 1;
   
end

x_data = x_data(1:end-1);
y_data = y_data(1:end-1);

% Adjust data for origin:

xo = x_ll;
yo = y_ll;

x_data = x_data - xo;
y_data = -y_data + yo;

% Rotate x and y data:

x_rot = x_data.*cos(beta) + y_data.*sin(beta);
y_rot = y_data.*cos(beta) - x_data.*sin(beta);

% Convert x and y into real units:

x_real = x_rot ./ xscale;
y_real = y_rot ./ yscale;

maxvalue = max(y_real);

% To find mean, integrate and divide:

[x_sort,i] = sort(x_real);
y_sort = y_real(i);

for(i=1:length(y_sort)-1)
   
   intval(i) = abs(x_sort(i+1) - x_sort(i)).*min([y_sort(i+1) y_sort(i)]) + ...
      abs(x_sort(i+1) - x_sort(i)).*(max([y_sort(i+1) y_sort(i)]) - ...
      min([y_sort(i+1) y_sort(i)]))./2;
   
end

meanvalue = sum(intval)./(max(x_sort) - min(x_sort));

x_out = x_real;
y_out = y_real;
