% load data

%cd /bigdisk/roland/work/GDINV/PAWT
%cd /bigdisk/roland/work/GDINV/BRUSH
cd /bigdisk/roland/GDINV/PAWT89_94


clear fort
load fort.29
rslip = fort(:,2);
clear fort
load fort.27
rcov = fort;
clear fort
load fort.28
AA = fort;
disp(' Fortran Files Read')
% load solution

%cd /bigdisk/roland/work/MYTHESIS3/ZEBU/PAWT
%cd /bigdisk/roland/work/MYTHESIS3/ZEBU/BRUSH
cd /halape/roland/MYTHESIS3/ZEBU/PAWT89_94

	[VEL,COV,NVEC,llh] = matrdvel('pawt_reference.vel');
%	[VEL,COV,NVEC,llh] = matrdvel('brus_reference.vel');
	disp(' Data File Read')
cd /deform/paul/matlab/loma
	nsta = NVEC+1;
	llh = llh(:,1:nsta);
	VEL = VEL(:,1:NVEC);
	COV = COV(1:3*(NVEC),1:3*(NVEC));

% plot observed vectors
% try converting from meters to mm
[a,b,az] = errlps( cov3d2cov2d(COV) );
  a = a/2.448;
  b = b/2.448;
  az = 90*ones(size(az)) - az;
outmatrix1 = [llh(2,1:NVEC)', llh(1,1:NVEC)', 1000*VEL(1,:)', 1000*VEL(2,:)',1000*a',1000*b',az'];
save obs.gmtvec outmatrix1 -ascii

% now we need to reformat A into the form
%        u = A*s
%the data file (*.VEL) and the matrix A
%Note there is an inconsistency in the number of stations between

	nfaults = 78
	A = zeros(nsta*3,nfaults);
for i=1:nsta
	first = (i-1)*nfaults+1;
	last  = first+nfaults-1;
	fl = (i-1)*3+1;
	A(fl+1,:) = AA(first:last,1)';  %North
	A(fl  ,:) = AA(first:last,2)';  %East
	A(fl+2,:) = AA(first:last,3)';  %Up
end

% now compute the predicted displacements

 u_temp = A*rslip;
 cov_u =  A*rcov*A';

% need to make the predicted displacements relative to the reference (LAST) station
  T = -eye(3);
  C = T;
  for i =1:nsta-2
	C = [C;T];
  end
  I = eye(3*(nsta-1)); 
  D = [I, C];
  u_rel = D*u_temp;
  cov_rel = D*cov_u*D';

% Scale covariance by 3^2 to match errors in pre-1989 data
  cov_rel = 9*cov_rel;

% put predicted displacements into 3, nstations format

  u_pre = zeros(3, nsta-1);
for i=1:nsta-1
	j = (i-1)*3+1;
	u_pre(:,i) = u_rel(j:j+2);
end

% plot predicted vectors
  [a,b,az] = errlps( cov3d2cov2d(cov_rel) );
  a = a/2.448;
  b = b/2.448;
  az = 90*ones(size(az)) - az;
  outmatrix2 = [llh(2,1:NVEC)', llh(1,1:NVEC)', 1000*u_pre(1,:)', 1000*u_pre(2,:)', 1000*a', 1000*b', az'];
save mod.gmtvec outmatrix2 -ascii

%this is to plot predicted vectors in "absolute" frame
%u_pre = zeros(3,nsta);
%for i=1:nsta
%	j = (i-1)*3+1;
%	u_pre(:,i) = u_temp(j:j+2);
%end
%[a,b,az] = errlps( cov3d2cov2d(cov_u) );
% outmatrix2 = [llh(2,:)', llh(1,:)', 1000*u_pre(1,:)', 1000*u_pre(2,:)',  1000*a', %1000*b', az'];
%save mod.gmtvec outmatrix2 -ascii

% some code to difference the pre-postseisic.
  Del = [I,-I];
  u_diff = Del*[VEL(:); 1.0*u_rel];
  cov_diff = Del*[ COV, zeros(size(COV)); zeros(size(cov_rel)), cov_rel]*Del';

% plot difference vectors

  u_diff_p = zeros(3, nsta-1);
for i=1:nsta-1
	j = (i-1)*3+1;
	u_diff_p(:,i) = u_diff(j:j+2);
end

[a,b,az] = errlps( cov3d2cov2d(cov_diff) );
  a = a/2.448;
  b = b/2.448;
  az = 90*ones(size(az)) - az;
  outmatrix3 = [llh(2,1:NVEC)', llh(1,1:NVEC)', 1000*u_diff_p(1,:)', 1000*u_diff_p(2,:)', 1000*a', 1000*b', az'];
save diff.gmtvec outmatrix3 -ascii


!test_loma.map
%% TO SAVE FOR LATER PROCESSING
%%  save LomaDiff llh u_diff_p cov_diff
%!check.map
