function u_rel = vol_rel_disp(nu, volgeom, xy)

[nsta,m] = size(xy);
nvec = nsta-1;
u = zeros(nsta,3);

%compute radius from center source.
X_e = xy(:,1) - ones(nsta,1)*volgeom(1);
X_n = xy(:,2) - ones(nsta,1)*volgeom(2);
r   = sqrt( X_e .^2 + X_n .^2);

%compute displacements %constant converts km to m
d = volgeom(3);
prefactor =  (1-nu)*1.0e3*volgeom(4)/(pi*d^2);

uz = prefactor*(1 + r.^2/d^2).^(-1.5);
ur = (prefactor/d)*r.*(1 + r.^2/d^2).^(-1.5);

% convert radial displacement to east north
theta = atan2(X_n, X_e);
ue = ur .* cos(theta);
un = ur .* sin(theta);
u = [ue, un, uz];

%  compute  displacements realtive to LAST station
u_rel = zeros(3,nvec);
u_rel(1,:) = u(1:nvec,1)' - u(nvec+1,1).*ones(1,nvec);
u_rel(2,:) = u(1:nvec,2)' - u(nvec+1,2).*ones(1,nvec);
u_rel(3,:) = u(1:nvec,3)' - u(nvec+1,3).*ones(1,nvec);
